Program UpToday;

Uses
    Dos,Crt,Misc;

Var
      Log,Cf                                  : Text;
      PceDir,MainDir                          : String;
      d,v,Conf,fz,c                           : Integer;
      x                                       : String;
      Today                                   : String[10];
      Files                                   : Array[1..2000] of String[12];
      Color1,Color2                           : String[10];

Function GDate : String;
Var
  y, m, d, dow : Word;
  Begin
    GetDate(y,m,d,dow);
    GDate:=Zero(y)+'-'+Zero(m)+'-'+Zero(d);
  End;

Procedure Help;
  Begin
    WriteLn('  Uses   : UPTODAY <Conf.Number> ');
    WriteLn('  Example: UPTODAY 3');
    WriteLn;
    Halt;
  End;

Procedure WriteAsc;
Begin
  FileMode:=1;
  Assign(cf,PceDir+'UPTODAY'+IntStr(Conf)+'.ASC');
  {$I-}
  Rewrite(cf);
  {$I+}
  If IOResult<>0 then Begin
    WriteLn('  Can''t open '+PceDir+'UPTODAY'+IntStr(Conf)+'.ASC');
    WriteLn;
    Halt;
  End;

  FileMode:=0;
  Assign(Log,MainDir+'HEADER.ASC');
  {$I-}
  Reset(Log);
  {$I+}
  If IOResult=0 then Begin
    While not eof(Log) do Begin
      ReadLn(Log,x);
      WriteLn(cf,x);
    End;
    Close(log);
  End;

  d:=0;
  Write(cf,' [');
  for v:=1 to 76 do Write(cf,'=');
  WriteLn(cf,']');
  If fz<>0 then Begin
    Repeat
      Write(cf,' ');
      For v:=1 to 5 do Begin
       Inc(d);
       Write(cf,' = ',Files[d]);
       for c:=1 to 12-Length(Files[d]) do Write(cf,' ');
      End;
      WriteLn(cf,' =');
    Until d>=fz;
  End;
  Write(cf,' [');
  for v:=1 to 76 do Write(cf,'=');
  WriteLn(cf,']');
  x:=' [  = uPLoaDeD !TODAY! (c) by MuHaDiB = NeW FiLeS CoNF.: '+IntStr(Conf);
  For v:=1 to 61-Length(x) do x:=x+' ';
  x:=x+' = '+Copy(Today,6,2)+'/'+Copy(Today,9,2)+'/'+Copy(Today,1,4)+' =  ]';
  WriteLn(cf,x);
  Write(cf,' [');
  for v:=1 to 76 do Write(cf,'=');
  WriteLn(cf,']');
  Close(cf);
End;

Procedure WriteAns;
Begin
  FileMode:=1;
  Assign(cf,PceDir+'UPTODAY'+IntStr(Conf)+'.ANS');
  {$I-}
  Rewrite(cf);
  {$I+}
  If IOResult<>0 then Begin
    WriteLn('  Can''t open '+PceDir+'UPTODAY'+IntStr(Conf)+'.ANS');
    WriteLn;
    Halt;
  End;

  FileMode:=0;
  Assign(Log,MainDir+'HEADER.ANS');
  {$I-}
  Reset(Log);
  {$I+}
  If IOResult=0 then Begin
    While not eof(Log) do Begin
      ReadLn(Log,x);
      WriteLn(cf,x);
    End;
    Close(log);
  End;

  d:=0;
  Write(cf,Color1);
  Write(cf,' [');
  for v:=1 to 76 do Write(cf,'=');
  WriteLn(cf,']');
  If fz<>0 then Begin
    Repeat
      Write(cf,Color2,' ');
      For v:=1 to 5 do Begin
       Inc(d);
       Write(cf,' = ',Files[d]);
       for c:=1 to 12-Length(Files[d]) do Write(cf,' ');
      End;
      WriteLn(cf,' =');
    Until d>=fz;
  End;
  Write(cf,Color1,' [');
  for v:=1 to 76 do Write(cf,'=');
  WriteLn(cf,']');
  Write(cf,Color1+' [  '+Color2);
  x:='= uPLoaDeD !TODAY! (c) by MuHaDiB = NeW FiLeS CoNF.: '+IntStr(Conf);
  For v:=1 to 57-Length(x) do x:=x+' ';
  x:=x+' = '+Copy(Today,6,2)+'/'+Copy(Today,9,2)+'/'+Copy(Today,1,4)+' ='+Color1+'  ]';
  WriteLn(cf,x);
  Write(cf,' [');
  for v:=1 to 76 do Write(cf,'=');
  WriteLn(cf,']');
  Write(cf,Chr(27)+'[0m'+Chr(27)+'[255D');
  Close(cf);
End;

Begin
  DirectVideo:=False;
  WriteLn;
  TextColor(Cyan);
  WriteLn(' UpToday ۲ v.1.0 (c) Dec. ''95 by MuHaDiB of AylA-BBs');
  NormVideo;
  WriteLn;
  PceDir:=GEnv('PCEXPRESS');
  MainDir:=MDir(ParamStr(0));
  Today:=GDate;

  If (ParamCount=0) or (Pos('?',ParamStr(1))<>0) then Help;

  FileMode:=0;
  Assign(Log,MainDir+'UPTODAY.CFG');
  {$I-}
  Reset(Log);
  {$I+}
  If IOResult=0 then Begin
    ReadLn(Log,Color1);
    ReadLn(Log,Color2);
    Close(Log);
  End;

  Conf:=StrInt(ParamStr(1));
  fz:=0;
  For d:=0 to 9 do Begin
    If fExist(PceDir+'UDLOG'+IntStr(d)+'.TXT') then Begin
      FileMode:=0;
      Assign(Log,PceDir+'UDLOG'+IntStr(d)+'.TXT');
      {$I-}
      Reset(Log);
      {$I+}
      If IOResult=0 then Begin
        While not eof(Log) do Begin
          ReadLn(Log,x);
          If Pos(Today,x)=1 then If Pos('conf:'+IntStr(Conf),x)<>0 then Begin
            If Pos(' up ',x)<>0 then Begin
              Inc(fz);
              Files[fz]:=Copy(x,Pos(' conf:'+IntStr(Conf),x)-12,12);
              While Pos(' ',Files[fz])<>0 do Delete(Files[fz],1,1);
            End;
          End;
        End;
        Close(Log);
      End;

    End;
  End;
  WriteLn('  Write UPTODAY',Conf,'.ASC ');
  WriteAsc;
  WriteLn('  Write UPTODAY',Conf,'.ANS ');
  WriteAns;
End.

