Program Rumours;

uses pkDoor,PkPort,pkMisc,protect;

type RumourBase=Record
      Rumour    : String[76];
      Klikspaan : String[30];
     end;

type RumourWriters=Record
      Writername    : String[30];
      Gossipspreads : Word;
     end;

const version='1.O';

var Rum_f    : File of RumourBase;
    I,Z,IMax,
    TopSpread: Word;
    Rumour   : RumourBase;
    Txt      : Text;
    Line,PStr: String;
    Ch       : Char;
    User_f,
    User_f2  : File of RumourWriters;
    User     : RumourWriters;
    TopName  : String[30];
    T,IOSAVE : Byte;

Procedure CreateUserFile;
begin
pkShareFile(false,false);
Assign(user_f2,'RUMOURS.WTR');
T:=0;
 repeat
  Inc(T);
  Rewrite(user_f2);
  IOSAVE:=IOResult;
 until (T > 20) or (IOSAVE=0);
 if T > 20 then
  begin
   pkln;
   pkWriteln('|04 |15Contact SysOp - Can''t write to RUMOURS.WTR!');
   halt;
  end;
user.writername:='MugSHot'; user.gossipspreads:=1;
write(user_f2,user); close(user_f2);
end;

Procedure AddRumour;
var Q : Byte;
begin
if not pkexist('RUMOURS.WTR') then createuserfile;
pkclrscr;
pkln;
pkln;
pkWriteln('|15 RUMOURS |07v|15'+version+'|07 (|15c|07) 1995|15 MugSHot');
pkln;
pkWriteln(' |15[-|07Enter Your Rumour Below|15,|07 Esc Aborts|15-]');
pkWrite(' |07['); pksetxy; for Q:=1 to 76 do pkWrite(' '); pkWrite(']');
pkresetxy;
pkWrite('|15');
pkReadln(Pstr,76,true);
if pkescaped then
 begin
  pkln;
  pkWriteln(' |07Rumour |15not|07 spread.');
  halt;
 end;
Assign(user_f,'RUMOURS.WTR');
T:=0;
repeat
 Inc(T);
 Reset(user_f);
 IOSAVE:=IOResult;
until (T > 20) or (IOSAVE=0);
 if T > 20 then
  begin
   pkln;
   pkWriteln('|04 |15Contact SysOp - Can''t read RUMOURS.WTR!');
   halt;
  end;

repeat read(user_f,user); until (pkupper(user.writername)=pkupper(pkdrop.name))
 or (eof(user_f));
if (pkupper(user.writername)=pkupper(pkdrop.name)) then
 begin
  Assign(user_f2,'RUMOURS.$$$');
  Reset(user_f);
  Rewrite(user_f2);
  while not eof(user_f) do
   begin
    read(user_f,user);
    if pkupper(user.writername)=pkupper(pkdrop.name)
     then user.gossipspreads:=user.gossipspreads+1;
    write(user_f2,user);
   end;
   close(user_f); close(user_f2); erase(user_f); rename(user_f2,'RUMOURS.WTR');
  end
 else
  begin
   user.writername:=pkdrop.name; user.gossipspreads:=1;
   write(user_f,user);
   close(user_f);
  end;
 pkln; pkWriteln(' |07Gossip Spreader Info Updated.');

Assign(rum_f,'RUMOURS.DAT');
Reset(rum_f);
while not eof(rum_f) do read(rum_f,rumour);
rumour.rumour:=Pstr; rumour.klikspaan:=pkdrop.name;
write(rum_f,rumour);
close(rum_f);
pkWriteln(' |07Rumour has been brought into circulation.');
halt;
end;

Procedure checkmci(var outstr:String);
var index,i:byte; wrkstr:String;
begin
 if rumour.klikspaan='' then rumour.klikspaan:='MugSHot';
 while pos('@',outstr) <> 0 do
 begin
  index:=pos('@',outstr);
  wrkstr:='';
  I:=0;
  repeat
   Inc(I);
   wrkstr:=wrkstr+outstr[index+i];
  until (wrkstr[i]='@') or (I > 13);
  if pkupper(wrkstr)='WRITERNAME@' then
   begin
    wrkstr:=rumour.klikspaan+copy(outstr,index+12,length(outstr)-length(rumour.klikspaan));
    outstr:=copy(outstr,1,index-1)+wrkstr;
   end
 else if pkupper(wrkstr)='RUMOUR@' then
   begin
    wrkstr:=pkpadcenter(rumour.rumour,76,' ')+copy(outstr,index+8,length(outstr)-length(rumour.rumour));
    outstr:=copy(outstr,1,index-1)+wrkstr;
   end
 else if pkupper(wrkstr)='TOTRUMOURS@' then
   begin
    wrkstr:=pkintstr(IMax,0)+copy(outstr,index+12,length(outstr)-length(pkintstr(iMax,0)));
    outstr:=copy(outstr,1,index-1)+wrkstr;
   end
 else if pkupper(wrkstr)='LOUDMOUTH@' then
   begin
    wrkstr:=topname+copy(outstr,index+11,length(outstr)-length(topname));
    outstr:=copy(outstr,1,index-1)+wrkstr;
   end
 else if pkupper(wrkstr)='RUMOURS@' then
   begin
    wrkstr:=pkintstr(topspread,0)+copy(outstr,index+9,length(outstr)-length(pkintstr(topspread,0)));
    outstr:=copy(outstr,1,index-1)+wrkstr;
   end
  else exit;
 end;
end;

begin
if pkdropfile=false then
 begin
  pkansi:=true;
  pkShowLogo('RUMOURS v'+version,'                (c) 1995 MugSHot');
  pkWriteln('|07RUMOURS -N[Node Number]');
  halt;
 end;

if not pkexist('RUMOURS.DAT') then
 begin
  pkansi:=true;
  pkShowLogo('RUMOURS v'+version,'                (c) 1995 MugSHot');
  pkWriteln('|04|07 Rumours not found! - RUMOURS.DAT that is...');
  halt;
 end;

PStr:=ParamStr(2);
if pkupper(PStr)='-GOSSIP' then addrumour;

if not pkexist('RUMOURS.WTR') then createuserfile;

iMax:=0;
pkShareFile(true,false);
Assign(rum_f,'RUMOURS.DAT');
T:=0;
repeat
 Inc(T);
 Reset(rum_f);
 IOSAVE:=IOResult;
until ( T > 20 ) or (IOSAVE=0);
if T > 20 then
 begin
  pkln;
  pkWriteln('|04 |15Contact SysOp - Can''t read RUMOURS.DAT');
  halt;
 end;
While not eof(rum_f) do
 begin
  Inc(iMAX);
  read(rum_f,rumour);
 end;
Reset(rum_f);
Randomize;
I:=Random(IMax);
Z:=0;
 repeat
  Inc(Z);
  read(rum_f,rumour);
 until I=Z;
close(rum_f);

TopSpread:=0;
Assign(user_f,'RUMOURS.WTR');
Reset(user_f);
While not eof(user_f) do
 begin
  read(user_f,user);
  if user.gossipspreads > TopSpread then
   begin TopName:=user.writername; TopSpread:=user.gossipspreads; end;
 end;
close(user_f);

Assign(txt,'rumours.msg');
Reset(txt);
while not eof(txt) do
 begin
  readln(txt,line);
  checkmci(line);
  pkWrite(line); pksetxy; pkWrite(CR+LF);
 end;
close(txt);
pkresetxy;
repeat
until pkkeypressed;
ch:=pkreadkey;
end.