Program What_Door;

Uses
      pkdoor,pkPort,pkMisc,dos,crt;          {PceKit 2.50}

Type
      {$I pkstruct.119}



Var
      fromNode,toNode,code                   : Integer;
      dsz,hitkey,Monitor,Terse,Active        : Boolean;
      dszf                                   : Text;
      mr                                     : MultiNodeRecord;
      mf                                     : File of MultiNodeRecord;
      ur                                     : UserRecord;
      uf                                     : File of UserRecord;
      dszr,dummy                             : String;
      x                                      : String;
      Status                                 : String[6];
      FileName                               : String[13];
      FileSize                               : String[8];
      r                                      : String[1];

{ ---------------------------------------------------------------------------------------- }

Procedure Stop;
  Begin
    pkLn;
    Halt;
  End;

{ ---------------------------------------------------------------------------------------- }

Function EnterChar(show : String; keys : String) : String;
Var
  Continue                : Boolean;
  ch                      : Char;
  k                       : Byte;

  Begin
    pkWrite(show);
    k:=0;
    Repeat
      ch:=UpCase(pkReadKey);
      If Pos(UpCase(Ch),keys)<>0 then Begin
        pkwrite(ch);
        Inc(k);
      End;
        If (ch=#13) then continue:=false
        Else if ch=#8 then Begin
          if K > 0 then pkWrite(#8+#32+#8);
          if K > 0 then K:=K-1;
        End
        Else if Pos(UpCase(Ch),keys)<>0 then continue:=false;
    Until (continue=false) ;
    EnterChar:=Ch;
  End;

{ ---------------------------------------------------------------------------------------- }

Function Select( s: String; k: String; d: String ) : String;
Var e: String;
  Begin
    e:=EnterChar(s,k);
    If e=#13 then Begin
      pkWrite(d);
      e:=d;
    End;
    pkLn;
    If e='Q' then Stop;
    Select:=e;
  End;

{ ---------------------------------------------------------------------------------------- }

Procedure Convert;
Var

  v     : Word;
  dummy : String[15];
  Begin
    FileName:='             ';
    FileSize:='        ';
    If      x[1]='l' Then Status:='Error '
    Else If x[1]='L' Then Status:='Error '
    Else Begin
      If x[1]='E' Then    Status:='Err UL';
      If x[1]='e' Then    Status:='Err DL';
      If x[1]='z' Then    Status:='D/Load';        { ZModem }
      If x[1]='Z' Then    Status:='U/Load';
      If x[1]='h' Then    Status:='D/Load';        { HSLink }
      If x[1]='H' Then    Status:='U/Load';
      If (x[1]='H') and (Pos('-1',x)=Length(x)-1) Then  Status:='D/Load';        { Hydra alt }
      If (x[1]='R') and (Pos('-1',x)=Length(x)-1) Then  Status:='U/Load';
      If (x[1]='h') and (Pos('-1',x)=Length(x)-1) Then  Status:='D/Load';        { Hydra neu }
      If (x[1]='H') and (Pos('-1',x)=Length(x)-1) Then  Status:='U/Load';
      Delete(x,1,1);
      While x[1]=' ' do Delete(x,1,1);
      v:=Pos(' ',x)-1;
      FileSize:=Copy('',1,8-v)+Copy(x,1,v);
      Delete(x,1,Pos(' errors ',x)+18);
      For v:=1 to Length(x) do x[v]:=UpCase(x[v]);
      For v:=1 to Length(x) do If x[v]='/' then x[v]:='\';
      While Pos('\',x)<>0 do Delete(x,1,Pos('\',x));
      If Pos(' ',x)<>0 then Delete(x,Pos(' ',x),255);
      FileName:=Copy(' ',1,13-Length(x))+x;
    End;

  End;

{ ---------------------------------------------------------------------------------------- }

Procedure Read_Dsz;
Var
  z,v           : Word;
  dummy,dummy2  : String;
  Begin
    If pkExist(dszr) then Begin
      FileMode:=2;
      Assign(dszf,dszr);
      {$I-}
      Reset(dszf);
      {$I+}
      If (IOResult=0) and (pkFileSize(dszr)>0) then Begin
        z:=0;
        While not eof(dszf) do Begin
          Inc(z);
          ReadLn(dszf,x);
          Convert;
          Str(z,dummy);
          dummy2:='';
          For v:=1 to 3-Length(dummy) do dummy2:=dummy2+' ';
          pkWrite('                                     ');
          pkWriteLn('|54|54'+dummy2+'|06[|07'+dummy+'|06] [|03'+Status+'|06] |11'+FileName+' |10'+Filesize+' |54|54');
        End;
        pkWrite('                                      ');
        pkWriteLn('|54;');
      End;
      {$I-}
      Close(dszf)
      {$I+}
    End;
  End;

{ ---------------------------------------------------------------------------------------- }

Procedure WhoOnline;
Var
  b,i2         : Byte;
  s,dummy      : string;
  Begin
    Assign (mf,pkBBsPath+'NODE.CFG');
    FileMode:=0;
    b:=0;
    Repeat
    Inc(b);
    {$I-}
    reset(mf);
    {$I+}
    Until (IOResult=0) or (b>40);
    If IOResult=0 then Begin
      b:=0;
      If fromNode>0 then Begin
        Repeat
          Read(mf,mr);
          inc(b);
        Until (b=fromNode) or (eof(mf));
      End;

      If IOResult=0 Then Begin
        For b:=fromNode to toNode do Begin
          s:='';
          read(mf,mr);
          If (Dsz) or (b=fromNode) or ((Monitor) and (b=fromNode)) then
            pkWriteLn('|54͸');
          If (Active) and (Length(mr.Name)<2) then Else Begin
            s:='|54|52 NODE |51'+pkIntStr(b,0)+' |54|52 ';
            dummy:=mr.name;
            If LENGTH(dummy)>25 Then Delete(dummy,25,25);
            s:=s+(dummy);
            For i2:=1 TO 26-LENGTH(mr.Name) Do s:=s+' ';
            s:=s+'|54|52';
            If mr.Name<>'' Then Begin                  {   String[38] }
              If mr.status=0 Then s:=s+' Browsing';
              If mr.status=1 Then s:=s+' U/Load: '+mr.extEndedstatus;
              If mr.status=2 Then s:=s+' D/Load: '+mr.extEndedstatus;
              If mr.status=3 Then s:=s+' Chatting';
              If mr.status=4 Then s:=s+' Door: '+mr.extEndedstatus;
              If mr.status=5 Then s:=s+' Reading Mail';
              If mr.status=6 Then s:=s+' Config';
              If mr.status=7 Then s:=s+' '+mr.extEndedstatus;
              If mr.status=8 Then s:=s+' Scanning Mail';
              If mr.status=9 Then s:=s+' Newuser: '+mr.extEndedstatus;
              If mr.status=10 Then s:=s+' Filecheck: '+mr.extEndedstatus;
              If mr.status=11 Then s:=s+' FileId: '+mr.extEndedstatus;
              If mr.status=12  Then s:=s+' View: '+mr.extEndedstatus;
              If mr.status=13  Then s:=s+' View Bulltins';
              If mr.status=14  Then s:=s+' Dosshell';
              If mr.status=15  Then s:=s+' Reciving Fax';
              If mr.status=16  Then s:=s+' Logging Off';
              If mr.status=17  Then s:=s+' Scan new files';
              If mr.status=18  Then s:=s+' Watching Filelist';
              If mr.status=19  Then s:=s+' Paging Sysop';
              If mr.status=20  Then s:=s+' Flagging Files';
              If mr.status=21  Then s:=s+' Writing Mail';
              If mr.status=22  Then s:=s+' Contacting Sysop';
              If mr.status=254 Then s:=s+' Resetting node';
              If mr.status=255 Then s:=s+' Waiting for call';
            End;
            For i2:=1 to 99-Length(s) do s:=s+' ';
            s:=s+'|54';

            pkWriteLn(s);

            If not Monitor then Begin
              s:='|54'+'        '+'|54|51 ';
              If LENGTH(mr.location)>25 Then Delete(mr.location,25,25);
              s:=s+mr.location;
              For i2:=1 TO 26-LENGTH(mr.location) do s:=s+(' ');
              s:=s+'|54|51';
              If      mr.baudrate=0   Then s:=s+'|51 ONLiNE'
              Else If mr.baudrate=255 Then s:=s+'|51 ONLINE'
              Else Begin
                str(mr.baudrate,dummy);
                s:=s+' Connect: |52'+dummy;
              End;
              For i2:=1 to 96-Length(s) do s:=s+' ';
              s:=s+'|54|51';
              pkWriteLn(s);
            End;
          End;
          If (toNode=b) and (Monitor) then
            pkWriteLn('|54;')
          Else If (dsz) or (toNode=b) then
            pkWriteLn('|54;')
          Else If not Monitor then
            pkWriteLn('|54Ĵ');
          If dsz=True then Begin
            dszr := pkBBsPath+'DSZLOG.'+pkIntStr(b,0);
            If pkExist(dszr) then Begin
              Read_Dsz;
            End;
          End;
        End;
        close(mf);
      End;

    End;
  End;

{ ---------------------------------------------------------------------------------------- }

Begin
  pkClrScr;
  pkAbout:=pkPadCenter(' WhAT''s going up ۲ v.1.6 (c) Okt. ''95 by MuHaDiB of AylA-BBs',78,' ');
  pkStatusBar(9);
  pkLn;
  If pkLocal then pkAnsi:=True;
  x:=ParamStr(2);
  Delete(x,1,1);
  Val(x,fromNode,code);
  x:=ParamStr(3);
  Delete(x,1,1);
  Val(x,toNode,code);

  dsz:=True;
  hitkey:=True;
  Active:=False;
  Terse:=False;
  Monitor:=False;

  If pkUpper(ParamStr(4))<>'-USER' then Begin
    If ParamStr(4)='-0' Then dsz:=False;
    If ParamStr(5)='-0' Then hitkey:=False;
    If pkUpper(ParamStr(5))='-M' Then Monitor:=True;
  End Else Begin
    pkLn;
    dummy:=' |54(|53V|54)|52erbose|53, |54(|53M|54)|52onitor |52or |54(|53A|54)|52ctive|51 : ';
    r:=Select('|51Display other nodes |54(|53T|54)|52erse|53, |54(|53B|54)|52rief|53,'+dummy,'TBVMA','V');
    pkLn;
    If r='T' then Begin
      Terse:=True;
      Monitor:=True;
    End;
    If r='M' then Monitor:=True;
    If r='A' then Begin
      Active:=True;
      Monitor:=True;
    End;
    If r='V' then dsz:=True;
    If r='B' then dsz:=False;
  End;

  If toNode=0 then toNode:=9;
  If toNode>9 then toNode:=9;
  If fromNode<0 then fromNode:=0;
  If fromNode>toNode then fromNode:=toNode-1;

  If Monitor then Begin
    dsz:=False;
    hitkey:=True;
  End;

  pkCursorOff;
  WhoOnline;

  pkWriteLn('                                      |54|54|06  WhAT''s going up v.1.6 by MuHaDiB  |54|54');
  pkWriteLn('                                       |54;|52 ');
  If HitKey then Begin
    pkWriteLn('|54(|53Hit any key|54)');
    Repeat
      If (Monitor) and (not Terse) and (not Active) then Begin
        pkGotoXY(1,5);
        delay(400);
        WhoOnline;
      End;
    Until pkKeyPressed;
  End;
 If Monitor then pkGotoXy(1,22);
 pkCursorOn;
End.




















